/*
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA  02110-1301, USA.

    ---
    Copyright (C) 2006, Alex Wilson <nikosai@dragonhold.ath.cx>
 */

#ifndef _main_h_
#define _main_h_

#include <QtCore>
#include <QtGui>

#include "ui_mainwindow.h"
#include "ui_copydialog.h"

class SudkVariable: public QObject {
	Q_OBJECT

	public:
		enum CalcType {
			Ti89, Ti92
		};

		SudkVariable(QFile *file, QObject *parent=0);
		SudkVariable(QObject *parent=0): QObject(parent) {}

		int get(int index);
		int get(int row, int column);

		QByteArray toWeb();
		QByteArray toVBForums();
		QByteArray toSadMan();
		QByteArray toSS();
		QByteArray toSPF();


	protected:
		void readFrom(QByteArray source);

	private:
		char _data[52];
		QString _folder;
		QString _name;
		CalcType _calc;
};

class CopyDialog : public QDialog, public Ui::CopyDialog {
	Q_OBJECT

	public:
		CopyDialog(QByteArray data, QWidget *parent=0);

	protected slots:
		void on_saveButton_clicked();

	private:
		QByteArray _data;
};

class MainWindow : public QMainWindow, public Ui::MainWindow {
	Q_OBJECT
	public:
		MainWindow(QWidget *parent=0);
		~MainWindow();

	public slots:
		void on_actionQuit_activated();
		//void on_actionSave_activated();
		void on_actionOpen_activated();

		void on_actionWeb_activated();
		void on_actionVBForums_activated();
		void on_actionSadMan_activated();
		void on_actionSS_activated();
		void on_actionSPF_activated();

		void refreshTable();

	private:
		QPointer<SudkVariable> _svar;
};

#endif // _main_h_
