/* Part of the SUDK sudoku puzzle solver/editor */
/* By Alex Wilson, copyright 2006 */

/* Solving algorithm based in part on the freeware work of
   Wim Colgate */

#ifndef _SUDOKU_H
#define _SUDOKU_H

#include <tigcclib.h>

#define CELL_WIDTH	LCD_WIDTH/9
#define CELL_HEIGHT	(LCD_HEIGHT-4)/9

typedef struct {
	unsigned char harray[41];
} sudoku;

typedef struct {
	int failures;
	int blanks;
} result;

int sudoku_get(sudoku *board, int index);
void sudoku_set(sudoku *board, int index, int value);
void drawOutline();
void highlight(int id);
void highlight_row(int row);
void highlight_column(int col);
void highlight_square(int basecol, int baserow);
void drawBoard(sudoku *board);
void drawCell(sudoku *board, int cell);
result check(sudoku *board);
result checkBoxes(sudoku *board);
result checkRows(sudoku *board);
result checkColumns(sudoku *board);

#endif
